/*
 *
 * AttributeMgr
 *
 * Central point for the attribute skill system in the mod
 *
 *
*/

package jesse.keeblarcraft.AttributeMgr;

import java.util.HashMap;
import java.util.List;

import jesse.keeblarcraft.Keeblarcraft;
import jesse.keeblarcraft.AttributeMgr.AttributeNodes.AbstractNode;
import jesse.keeblarcraft.AttributeMgr.AttributeNodes.AttributeFlight;
import jesse.keeblarcraft.ConfigMgr.ConfigManager;
import jesse.keeblarcraft.Utils.ChatUtil;

public class AttributeMgr {
    ConfigManager config;

    public static final HashMap<String, AbstractNode> attributes = new HashMap<String, AbstractNode>();

    @SuppressWarnings("deprecation")
    public static void RegisterAttributeClass(Class<? extends AbstractNode> classObj) {
        AbstractNode test;
        ChatUtil.LoggerColored("Registring attribute called", ChatUtil.CONSOLE_COLOR.CYAN, Keeblarcraft.LOGGER);
        try {
            test = classObj.newInstance();
            if (attributes.containsKey(test.GetNodeTitle())) {
                Keeblarcraft.LOGGER.warn("Could not register attribute with duplicate name '" + test.GetNodeTitle() + "'");
            } else {
                ChatUtil.LoggerColored("REGISTERING ATTRIBUTE " + test.GetNodeTitle(), ChatUtil.CONSOLE_COLOR.YELLOW, Keeblarcraft.LOGGER);
                attributes.put(test.GetNodeTitle(), test);
            }
        } catch (InstantiationException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
    }

    public static String ApplyAttribute(String uuid, String attributeName) {
        String msg = "";
        if (attributes.containsKey(attributeName)) {
            AttributeTree playerTree = new AttributeTree(uuid);
            AbstractNode node = attributes.get(attributeName);

            ///////////
            // debug testing
            String isNull = (node == null ? "NULL" : "NOT NULL");
            System.out.println("Node is " + isNull);
            if (isNull.equals("NOT NULL")) { System.out.println("Node name: " + node.GetNodeTitle()); }
            // end debug testing
            ///////////

            playerTree.AddNewNode(node, 1, null, null); ///TODO: Make handling in AttributeTree of NULL parents list to be defaulted to ROOT
            msg = "Applied attribute '" + attributeName + "' successfully";
        } else {
            msg = "Could not apply attribute, attribute name does not exist!";
        }
        return msg;
    }

    public static void RegisterAttributes() {
        // Manually register all attribute node classes here
        /// TODO: Find a better way to do this more dynamically in the future

        RegisterAttributeClass(AttributeFlight.class);
    }
}
